<?php


// Contemplate Reporter database import tool
// For importing data from before versions older than 2.0
// Copyright 2010 Arlo Leach (http://www.arlomedia.com)
// This product includes software developed by Type A Learning Agency (http://www.typea.net)
// This file may be used, modified, or redistributed under the terms
// of the open-source agreement contained in docs/license.txt


// get configuration settings

	include "../config/constants.php";
	ini_set("memory_limit", "64M");


// connect to the database

	@$database_connection = mysql_connect(REPORTER_DATABASE_ADDRESS, REPORTER_DATABASE_USERNAME, REPORTER_DATABASE_PASSWORD);
	if (!$database_connection) {
		exit("Could not connect to database at ".REPORTER_DATABASE_ADDRESS);
	} else {
		@$database_selected = mysql_select_db(REPORTER_DATABASE_NAME);
		if (!$database_selected) {
			exit("Could not select database ".REPORTER_DATABASE_NAME);
		}
	}
	

// define our internal functions

	function get_query_argument($name, $type, $default="") {
		// return the value from the $_GET array, or an empty string if the argument doesn't exist
		
		// we'll forbid users from creating arguments that might interfere with data we get through the query string
		GLOBAL $reserved_argument_names;
		$reserved_argument_names[] = $name;
		
		if (isset($_GET[$name])) {
			$value = $_GET[$name];
		} else if ($default) {
			$value = $default;
		} else {
			switch ($type) {
				case "bool": $value = false; break;
				case "name": $value = ""; break;
				case "filename": $value = ""; break;
				case "text": $value = ""; break;
			}
		}
		$value = sanitize($value, $type);

		return $value;
	}
	
	function sanitize($value, $type) {
		// remove any unnecessary characters that could be used for an exploit
		switch ($type) {
			case "bool": settype($value, "bool"); break;
			case "name": $value = preg_replace("/\W/", "", $value); break;
			case "filename": $value = preg_replace("/[^\w-\.,\/\?\&\=\% \+]/", "", $value); break;
			case "text": break;
		}
		return $value;
	}

	function get_file_simple($file) {
		unset($text);
		$text = "";

		$file = preg_replace("/[^\w-\.\/\?\&\=\%]/", "", $file, -1); // don't read files whose names contain characters that could be used to read remote files, or to hack into the open command (Perl only)
		$file = absolute_path($file, "filesystem");
		if (!$myfile = @fopen($file, "r")) {
			return "Error: Can't find file $file";
		} else {
			while (!feof($myfile)) { $text .= fread($myfile, 4096); }
			fclose ($myfile);
		}		
		
		// conform all line breaks to avoid cross-platform issues
		$text = str_replace("\r\n", "\n", $text); // change DOS to Unix
		$text = str_replace("\r", "\n", $text); // change Mac to Unix
		
		// remove extra line breaks at the end of the file so all the languages perform splits in the same way
		$text = trim($text); // preg_replace("/(.*[^\r])\r*$/", "$1", $text, -1);
		
		return $text;
	}
	
	function absolute_path($path, $method) { // convert a reference to a file within our site to a complete filesystem path or absolute URL
		GLOBAL $output, $script_location, $request, $URL_rewriting_flag;

		if ($method == "filesystem") {
		
			if ($script_location == "NA") {
				$output .= show_error("Couldn't determine the filesystem path to this script. Please ensure that either the SCRIPT_FILENAME or PATH_TRANSLATED variable is available on your server.");
			} else {
				$script_location_copy = $script_location;
				$file_copy = $path;
				while (strstr($file_copy, "../")) {
					// this avoids results like contemplate/../templates/default.html
					$script_location_copy = preg_replace("/[^\/]+\/$/", "", $script_location_copy, 1); // remove the last directory name from the script location
					$file_copy = preg_replace("/\.\.\//", "", $file_copy, 1); // remove the first updelim from the filename (in PHP, we need to use preg_replace so we only do one replacement)
				}
				$path = $script_location_copy.$file_copy;
			}
			
		} else {
		
			if ($request == "NA") {
				$output .= show_error("Couldn't determine the web path to this script. Please ensure that either the SCRIPT_NAME or REQUEST_URI variable is available on your server.");
			} else {
				$thisserver = (isset($_SERVER["HTTP_HOST"])) ? $_SERVER["HTTP_HOST"] : "" ;
				$thispath = "";
				if ($URL_rewriting_flag) {
					if (preg_match("/\/([^=]*\/)$URL_rewriting_flag\//i", $request, $matches)) { $thispath = $matches[1]; }
				} else {
					if (preg_match("/\/([^=]*\/)contemplate\//i", $request, $matches)) { $thispath = $matches[1]; }
				}
				
				// pass along the authentication information if present
				$login = (isset($_SERVER["PHP_AUTH_USER"])) ? $_SERVER["PHP_AUTH_USER"].":".$_SERVER["PHP_AUTH_PW"]."@" : "" ; 
				
				$path = preg_replace("/\.\.\//", "http://$login$thisserver/$thispath", $path, 1); // replace the first updelim with the scheme and path (in PHP, we need to use preg_replace so we only do one replacement)
				$path = str_replace("../", "", $path); // remove additional updelims
			}
			
		}
		
		return $path;
	}

	
// set up some primary variables

	// try to figure out the path to this script as it appears in the browser, before any URL rewriting
	// in IIS, this probably won't work, because REQUEST_URI will either not exist, or will show the path after rewriting, since rewriting is handled externally from IIS
	$request = "NA";
	if (isset($_SERVER["REQUEST_URI"])) {
		$request = $_SERVER["REQUEST_URI"];
		if (strpos($request, "?") !== false) {
			$request = substr($request, 0, strpos($request, "?"));
		}
	} else {
		// IIS doesn't always provide the REQUEST_URI variable
		if (isset($_SERVER["SCRIPT_NAME"])) {
			$request = $_SERVER["SCRIPT_NAME"];
		}
	}
	
	// we don't do URL rewriting except in the assembler, so this value should be empty
	// also, we can't tell what flag(s) the assembler is using, but we can set a default here
	$URL_rewriting_flag = "";
	$URL_rewriting_flag_default = "assembled";

	// figure out the full local path of the contemplate directory so we can build an absolute path that works on Windows computers
	// on Unix, this will include any symlinks used to construct the URL, so we can run the script from a symlink to the real contemplate folder, 
	// and paths will be relative to the apparent, rather than the actual, location of assembler.asp
	// on Windows, this will not include virtual directories, but constructing a path from a virtual directory wouldn't work anyway
	// because those aren't available at the file system level
	$script_location = "NA";
	if (isset($_SERVER["SCRIPT_FILENAME"])) {
		$script_location = $_SERVER["SCRIPT_FILENAME"];
	} else {
		// Windows doesn't provide the SCRIPT_FILENAME variable
		if (isset($_SERVER["PATH_TRANSLATED"])) {
			$script_location = $_SERVER["PATH_TRANSLATED"];
		}
	}
	$script_location = str_replace("\\", "/", $script_location);
	$script_location = str_replace("//", "/", $script_location); // not sure why PHP returns double slashes on Windows
	if (($URL_rewriting_flag)&&(preg_match("/(.*\/)$URL_rewriting_flag\//i", $script_location, $matches))) {
		$script_location = $matches[1]."contemplate/";
	} else {
		$script_location = preg_replace("/(.*\/)[^\/]+/", "$1", $script_location, 1);
	}


// set up the HTML page

	print "
	
		<html>
	
		<head>
		
			<title>Contemplate(tm) Web Templating System</title>
			
			<link rel=\"stylesheet\" href=\"styles.css\" type=\"text/css\">

		</head>
		
		<body bgcolor=\"#FFFFFF\">
				
			<p class=\"title\" style=\"margin-bottom: 24px;\">Reporter Import Tool</p>
			
	";

	if (isset($_POST["data_directory"])&&isset($_POST["confirm"])) {

		if (!$dir = @opendir(absolute_path($_POST["data_directory"], "filesystem"))) {
			print "<p class=\"body\"><b>Error:</b> Can't read the contents of the data directory ".$_POST["data_directory"]."</p>\n\n";
		} else {
			print "<p class=\"body\">\n";

			$data_files = Array();
			while ($file = readdir($dir)) {
				if (preg_match("/^\d{4}-\d{2}\.txt$/", $file)) {
					$data_files[] = $file;
				}
			}
			closedir($dir);
			sort($data_files);

			$_POST["data_directory"] = preg_replace("/(.*)\/$/", "$1", $_POST["data_directory"]);

			foreach ($data_files as $name) {
				//$columns_expected = (strpos($name, "errors") === false) ? 7 : 8 ;
				if (!USE_COOKIES_TO_TRACK_VISITORS) { $columns_expected--; }
				$lines_imported = 0;
				
				unset($data);
				unset($errors);
				unset($text);
				
				$data = get_file_simple($_POST["data_directory"]."/".$name);
				$errors = get_file_simple($_POST["data_directory"]."/".str_replace(".txt", "-errors.txt", $name));
				$text = $data.$errors; // we have to merge the data and error files together and sort the result so we can process each entry in the right order
				$text = explode("\n", $text);
				sort($text);
				foreach ($text as $line) {
					$line = explode("\t", $line);
					if ((count($line) == 7)||(count($line) == 8)) { // the error lines should have 8, but we've merged the files together so we can't tell which this is
						// get the values from this log entry
						if (USE_COOKIES_TO_TRACK_VISITORS) {
							//if (strpos($name, "errors") === false) {
								list($timestamp, $visitor_id, $ip_address, $host, $page, $user_agent, $referrer) = $line;
								$error = (isset($line[7])) ? $line[7] : "" ;
							//	$error = "";
							//} else {
							//	list($timestamp, $visitor_id, $ip_address, $host, $page, $user_agent, $referrer, $error) = $line;
							//}
						} else {
							//if (strpos($name, "errors") === false) {
								list($timestamp, $ip_address, $host, $page, $user_agent, $referrer) = $line;
								$visitor_id = "(visitors not tracked)";
								$error = (isset($line[6])) ? $line[6] : "" ;
							//	$error = "";
							//} else {
							//	list($timestamp, $ip_address, $host, $page, $user_agent, $referrer, $error) = $line;
							//	$visitor_id = "";
							//}
						}
						
						// separate an HTTP status code from an assembler error message
						if ((strval(intval($error)) === $error)||($error == "Unknown")) {
							$http_status = ($error == "Unknown") ? 0 : $error ;
							$error = "";
						} else {
							$http_status = 200;
						}
						
						// escape any quotes that might be in the error message, for the database query
						$assembler_error = addslashes($error);
					
						// if we're tracking visitors, set the duration of the previous view from this visitor, and the entry status for this page view
						if ((USE_COOKIES_TO_TRACK_VISITORS)&&($visitor_id)) {
							$query = "
								UPDATE `".REPORTER_DATABASE_TABLE."`
								SET `exit`=0, duration=ABS(UNIX_TIMESTAMP('$timestamp')-UNIX_TIMESTAMP(timestamp))
								WHERE visitor_id='$visitor_id'
								AND (UNIX_TIMESTAMP('$timestamp')-UNIX_TIMESTAMP(timestamp))<(".(MINUTES_UNTIL_VISIT_EXPIRES * 60).")
								AND `exit`=1
								ORDER BY timestamp DESC
								LIMIT 1
							";
							$result = mysql_query($query);
							$entry = (mysql_affected_rows()) ? 0 : 1 ;
						} else {
							$entry = 0;
						}
						
						// log this page view; we'll set the duration to -1 so we can distinguish between an unset duration and a duration of less than a second (more importantly, so the mysql_affected_rows command above can)
						$query = "INSERT INTO `".REPORTER_DATABASE_TABLE."` (
							timestamp,
							visitor_id,
							ip_address,
							host,
							page,
							user_agent,
							referrer,
							entry,
							`exit`,
							duration,
							http_status,
							assembler_error
						) VALUES (
							'$timestamp',
							'$visitor_id',
							'$ip_address',
							'$host',
							'$page',
							'$user_agent',
							'$referrer',
							 $entry,
							 1,
							 0,
							'$http_status',
							'$assembler_error'
						)";
						$result = mysql_query($query);
						
						if ($result) { $lines_imported++; }
					}
				}
				
				print "Imported $lines_imported entries from $name and ".str_replace(".txt", "-errors.txt", $name)."<br />\n";
				flush();
			}
			print "</p>\n";
		}
		
	} else if (isset($_POST["data_directory"])) {

		if (!$dir = @opendir(absolute_path($_POST["data_directory"], "filesystem"))) {
			print "<p class=\"body\"><b>Error:</b> Can't read the contents of the data directory ".$_POST["data_directory"]."</p>\n\n";
		} else {
			$data_files = Array();
			while ($file = readdir($dir)) {
				if ((preg_match("/^\d{4}-\d{2}\.txt$/", $file))||(preg_match("/^\d{4}-\d{2}-errors\.txt$/", $file))) {
					$data_files[] = $file;
				}
			}
			closedir($dir);
			sort($data_files);

			print "<form method=\"post\">\n";
			print "<p class=\"subheading\">Okay to import the following files?</p>\n";
			print "<p class=\"body\">".implode("<br />\n", $data_files)."</p>\n";
			print "<input type=\"hidden\" name=\"data_directory\" value=\"".$_POST["data_directory"]."\" />\n";
			print "<input type=\"hidden\" name=\"confirm\" value=\"1\" />\n";
			print "<input type=\"submit\" value=\"Import\">\n";
			print "</form>\n";
		}
	
	} else {
	
		print "<p class=\"subheading\">Enter the directory of your data files as a relative path</p>\n";
		print "<p class=\"body\">(e.g., ../../contemplate_old/data/reporter)</p>\n";
		
		print "<form method=\"post\">\n";
		print "<input type=\"text\" size=\"48\" name=\"data_directory\" />\n";
		print "<input type=\"submit\" value=\"Continue\">\n";
		print "</form>\n";

	}
	

// we're done!

	print "</body></html>\r";

?>